<template>
  <AppFlexCenterLayout class="h-full m-auto">
    <div class="card text-center shadow-2xl lg:card-side shadow-xl">
      <div class="card-body">
        <div v-if="connectionFailed" class="alert alert-error">
          <div class="flex-1">
            <svg
              xmlns="http://www.w3.org/2000/svg"
              fill="none"
              viewBox="0 0 24 24"
              class="w-6 h-6 mx-2 stroke-current"
            >
              <path
                stroke-linecap="round"
                stroke-linejoin="round"
                stroke-width="2"
                d="M18.364 18.364A9 9 0 005.636 5.636m12.728 12.728A9
                9 0 015.636 5.636m12.728 12.728L5.636 5.636"
              />
            </svg>
            <label>Connection failed or was aborted. Please try again.</label>
          </div>
        </div>
        <div v-else>
          <p v-show="address">Your address: {{ address }}</p>
        </div>

        <div class="justify-center card-actions">
          <button
            v-show="!address"
            class="btn btn-outline btn-accent glass font-bold"
            @click="connect"
          >
            Connect to Metamask
          </button>
        </div>
      </div>
    </div>
  </AppFlexCenterLayout>
</template>

<script lang="ts">
import { ethers } from 'ethers'
import Vue from 'vue'

interface MetamaskPageData {
  address: string
  balance: number
  signer: ethers.Signer | undefined
  provider: ethers.providers.Web3Provider | undefined
  connectionFailed: boolean
}

export default Vue.extend({
  name: 'MetamaskPage',
  data() {
    return {
      address: '',
      balance: 0,
      signer: undefined,
      provider: undefined,
      connectionFailed: false
    } as MetamaskPageData
  },
  methods: {
    async connect(): Promise<void> {
      this.$Web3.setProvider(window.ethereum)
      try {
        this.connectionFailed = false
        await this.$Web3.connect()
        this.signer = await this.$Web3.getSigner()
        this.provider = await this.$Web3.getProvider()
        this.address = await this.signer.getAddress()
      } catch (e) {
        this.connectionFailed = true
        // eslint-disable-next-line no-console
        console.error(e)
      }
    },
    async getBalance(): Promise<void> {
      const bigBalance = await this.provider?.getBalance(this.address)
      if (!bigBalance) {
        return
      }
      this.balance = bigBalance.toNumber()
    }
  }
})
</script>
